package {{consumer_package_name}};

import {{interface_package_name}}.DemoService;

{{#is_xml}}
import org.springframework.context.support.ClassPathXmlApplicationContext;
{{/is_xml}}

{{#is_annotation}}
{{#is_dubbo_after_270}}
import org.apache.dubbo.config.spring.context.annotation.EnableDubbo;
{{/is_dubbo_after_270}}
{{^is_dubbo_after_270}}
import com.alibaba.dubbo.config.spring.context.annotation.EnableDubbo;
{{/is_dubbo_after_270}}
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;
{{/is_annotation}}

public class Application {
    /**
     * In order to make sure multicast registry works, need to specify '-Djava.net.preferIPv4Stack=true' before
     * launch the application
     */
    public static void main(String[] args) {
        {{#is_xml}}
        ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext("spring/dubbo-consumer.xml");
        context.start();
        DemoService demoService = context.getBean("demoService", DemoService.class);
        String hello = demoService.sayHello("world");
        {{/is_xml}}
        {{#is_annotation}}
        AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext(ConsumerConfiguration.class);
        context.start();
        DemoService service = context.getBean("demoServiceComponent", DemoServiceComponent.class);
        String hello = service.sayHello("world");
        {{/is_annotation}}
        System.out.println("result: " + hello);
    }

    {{#is_annotation}}
    @Configuration
    @EnableDubbo(scanBasePackages = "{{consumer_package_name}}")
    @PropertySource("classpath:/dubbo.properties")
    @ComponentScan(value = {"{{consumer_package_name}}"})
    static class ConsumerConfiguration {

    }
    {{/is_annotation}}
}
