package {{consumer_package_name}};

import {{interface_package_name}}.DemoService;

{{#is_dubbo_after_270}}
import org.apache.dubbo.config.annotation.Reference;
{{/is_dubbo_after_270}}
{{^is_dubbo_after_270}}
import com.alibaba.dubbo.config.annotation.Reference;
{{/is_dubbo_after_270}}

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.ApplicationRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.context.annotation.Bean;

@EnableAutoConfiguration
public class DubboConsumerBootstrap {

    private final Logger logger = LoggerFactory.getLogger(getClass());


    @Reference(version = "1.0.0"{{#is_registry_multicast}}, url = "dubbo://127.0.0.1:12345"{{/is_registry_multicast}})

    private DemoService demoService;

    public static void main(String[] args) {
        SpringApplication.run(DubboConsumerBootstrap.class).close();
    }

    @Bean
    public ApplicationRunner runner() {
        return args -> logger.info(demoService.sayHello("Provider"));
    }
}
