package {{provider_package_name}};

{{#is_xml}}
import org.springframework.context.support.ClassPathXmlApplicationContext;
{{/is_xml}}

{{#is_annotation}}
{{#is_dubbo_after_270}}
import org.apache.dubbo.config.RegistryConfig;
import org.apache.dubbo.config.spring.context.annotation.EnableDubbo;
{{/is_dubbo_after_270}}
{{^is_dubbo_after_270}}
import com.alibaba.dubbo.config.RegistryConfig;
import com.alibaba.dubbo.config.spring.context.annotation.EnableDubbo;
{{/is_dubbo_after_270}}
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;
{{/is_annotation}}

public class Application {
    /**
     * In order to make sure multicast registry works, need to specify '-Djava.net.preferIPv4Stack=true' before
     * launch the application
     */
    public static void main(String[] args) throws Exception {
        {{#is_xml}}
        ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext("spring/dubbo-provider.xml");
        {{/is_xml}}
        {{#is_annotation}}
        AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext(ProviderConfiguration.class);
        {{/is_annotation}}
        context.start();
        System.in.read();
    }

    {{#is_annotation}}
    @Configuration
    @EnableDubbo(scanBasePackages = "{{provider_package_name}}")
    @PropertySource("classpath:/dubbo.properties")
    static class ProviderConfiguration {
        @Bean
        public RegistryConfig registryConfig() {
            RegistryConfig registryConfig = new RegistryConfig();
            {{#is_registry_multicast}}
            registryConfig.setAddress("multicast://224.5.6.7:1234");
            {{/is_registry_multicast}}
            {{#is_registry_zookeeper}}
            registryConfig.setAddress("zookeeper://localhost:2181");
            {{/is_registry_zookeeper}}
            {{#is_registry_nacos}}
            registryConfig.setAddress("nacos://localhost:8848");
            {{/is_registry_nacos}}
            {{#is_registry_edas}}
            registryConfig.setAddress("edas://47.93.244.38:8080");
            {{/is_registry_edas}}
            return registryConfig;
        }
    }
    {{/is_annotation}}
}
